CodeForces 292D Connected Components(变种并查集+预处理)

97 篇文章 0 订阅
11 篇文章 0 订阅

We already know of the large corporation where Polycarpus works as a system administrator. The computer network there consists of n computers and m cables that connect some pairs of computers. In other words, the computer network can be represented as some non-directed graph with n nodes and m edges. Let's index the computers with integers from 1 to n, let's index the cables with integers from 1 to m.

Polycarpus was given an important task — check the reliability of his company's network. For that Polycarpus decided to carry out a series of k experiments on the computer network, where the i-th experiment goes as follows:

  1. Temporarily disconnect the cables with indexes from li to ri, inclusive (the other cables remain connected).
  2. Count the number of connected components in the graph that is defining the computer network at that moment.
  3. Re-connect the disconnected cables with indexes from li to ri (that is, restore the initial network).

Help Polycarpus carry out all experiments and for each print the number of connected components in the graph that defines the computer network through the given experiment. Isolated vertex should be counted as single component.

Input

The first line contains two space-separated integers nm (2 ≤ n ≤ 500; 1 ≤ m ≤ 104)— the number of computers and the number of cables, correspondingly.

The following m lines contain the cables' description. The i-th line contains space-separated pair of integers xiyi (1 ≤ xi, yi ≤ nxi ≠ yi) — the numbers of the computers that are connected by the i-th cable. Note that a pair of computers can be connected by multiple cables.

The next line contains integer k (1 ≤ k ≤ 2·104) — the number of experiments. Next k lines contain the experiments' descriptions. The i-th line contains space-separated integers liri (1 ≤ li ≤ ri ≤ m) — the numbers of the cables that Polycarpus disconnects during the i-th experiment.

Output

Print k numbers, the i-th number represents the number of connected components of the graph that defines the computer network during the i-th experiment.

Example
Input
6 5
1 2
5 4
2 3
3 1
3 6
6
1 3
2 5
1 5
5 5
2 4
3 3
Output
4
5
6
3
4
2

题解:

题意:

给你一张节点数为n的图,然后给m条边的情况,然后是s组询问,问你去掉[l,r]范围内的边最后可以形成多少个连通块

思路:

一开始用dfs暴力写,华丽地tle了,然后想到了并查集,然后又暴力写,又是tle,冷静下来以后发现每次都求一遍并查集很浪费时间,然后就想到了预处理一遍,因为每次都是除去[l,r]后的情况,那么就可以先预处理一遍加入了[1,l-1]的边的情况和加入了[r+1,m]的边的情况,然后合并这两个集合就可以了,然后就枚举这些情况保存下来备用

代码:

#include<iostream>
#include<cstring>
#include<stdio.h>
#include<math.h>
#include<string>
#include<stdio.h>
#include<queue>
#include<stack>
#include<map>
#include<vector>
#include<deque>
#include<algorithm>
#define ll long long
#define INF 1008611111
#define M (t[k].l+t[k].r)/2
#define lson k*2
#define rson k*2+1
using namespace std;
struct edge
{
    int f,t;
}a[10005];
int prel[10005][505];
int prer[10005][505];
int ppre[505];
int find(int pre[],int x)
{
    if(pre[x]!=x)
        pre[x]=find(pre,pre[x]);
    return pre[x];
}
int l,r;
int main()
{
    int i,j,n,m,x,y,s,d1,d2;
    scanf("%d%d",&n,&m);
    for(i=1;i<=m;i++)
    {
        scanf("%d%d",&x,&y);
        a[i].f=x;
        a[i].t=y;
    }
    for(j=1;j<=n;j++)
    {
        prel[0][j]=j;
    }
    for(i=1;i<=m;i++)
    {
        for(j=1;j<=n;j++)
        {
            prel[i][j]=prel[i-1][j];
        }
        d1=find(prel[i],a[i].f);
        d2=find(prel[i],a[i].t);
        if(d1!=d2)
        {
            prel[i][d2]=d1;
        }
    }
    for(j=1;j<=n;j++)
    {
        prer[m+1][j]=j;
    }
    for(i=m;i>=1;i--)
    {
        for(j=1;j<=n;j++)
        {
            prer[i][j]=prer[i+1][j];
        }
        d1=find(prer[i],a[i].f);
        d2=find(prer[i],a[i].t);
        if(d1!=d2)
        {
            prer[i][d2]=d1;
        }
    }
    scanf("%d",&s);
    while(s--)
    {
        scanf("%d%d",&l,&r);
        int ans=0;
        if(l>r)
            swap(l,r);
        for(i=1;i<=n;i++)
        {
            ppre[i]=prel[l-1][i];
            //printf("prel[%d]=%d!!\n",i,ppre[i]);
        }
        for(i=1;i<=n;i++)
        {
            d1=find(ppre,i);
            d2=find(prer[r+1],i);
            d2=find(ppre,d2);
            //printf("prer[%d]=%d!!\n",i,d2);
            if(d1!=d2)
            {
                ppre[d2]=d1;
            }
        }
        for(i=1;i<=n;i++)
        {
            if(ppre[i]==i)
                ans++;
        }
        printf("%d\n",ans);
    }
    return 0;
}



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值